Unit QSK1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QSK1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);

implementation

procedure QSK1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);
var
C,M,N,P,T :Integer;
D,G,H,J,L,Q,R,S :Real;
const
K1E9 :Real = 1.0E9;
KMAX :Integer = 1048576;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21;
begin
IERR := 0;
K := Abs(K);
if ( K = 0 ) 
 then goto _21;
C := 0;
_1:
if ( C ) < 0
 then goto _3
 else if ( C ) > 0
       then goto _3
       else goto _2;
_2:
M := 0;
_3:
if ( M ) < 0
 then goto _5
 else if ( M ) > 0
       then goto _5
       else goto _4;
_4:
N := 0;
J := 0.0;
R := B-A;
Q := F(A)+F(B);
_5:
S := R/K;
if ( N ) < 0
 then goto _8
 else if ( N ) > 0
       then goto _8
       else goto _6;
_6:
P := K-1;
if ( P = 0 ) 
 then goto _8;
for T:=1 to P do
 begin
  J := J+F(A+T*S);
_7:
 end;
_8:
if ( N-1 ) < 0
 then goto _11
 else if ( N-1 ) > 0
       then goto _9
       else goto _9;
_9:
J := F(A+S);
P := (K-2) div 2;
if ( P = 0 ) 
 then goto _11;
for T:=1 to P do
 begin
  J := J+F(A+(2*T+1)*S);
_10:
 end;
_11:
Q := 2.0*J+Q;
J := Q*S/2.0;
N := N+1;
if ( N-1 ) < 0
 then goto _13
 else if ( N-1 ) > 0
       then goto _13
       else goto _12;
_12:
K := 2*K;
L := J;
goto _5;
_13:
if ( Abs(J-L)-K1E9 ) < 0
 then goto _14
 else if ( Abs(J-L)-K1E9 ) > 0
       then goto _12
       else goto _14;
_14:
INT := J;
INT := (4.0*INT-L)/3.0;
M := M+1;
if ( M-1 ) < 0
 then goto _16
 else if ( M-1 ) > 0
       then goto _16
       else goto _15;
_15:
K := 2*K;
D := INT;
L := J;
goto _3;
_16:
if ( Abs(INT-D)-K1E9 ) < 0
 then goto _17
 else if ( Abs(INT-D)-K1E9 ) > 0
       then goto _15
       else goto _17;
_17:
H := D;
D := INT;
INT := (16.0*INT-H)/15.0;
if ( E ) < 0
 then goto _21
 else if ( E ) > 0
       then goto _18
       else goto _21;
_18:
C := C+1;
if ( C-1 ) < 0
 then goto _20
 else if ( C-1 ) > 0
       then goto _20
       else goto _19;
_19:
K := 2*K;
G := INT;
L := J;
if ( K < KMAX ) 
 then goto _1;
IERR := 65;
K := KMAX;
UTQS10(IERR,3);
goto _21;
_20:
if ( Abs(INT-G)-E ) < 0
 then goto _21
 else if ( Abs(INT-G)-E ) > 0
       then goto _19
       else goto _21;
_21:
end;

end.
